#include <Wire.h>
#include "RTClib.h"

#define DS    7 //data pin
#define SHCP  8 //clock pin
#define STCP  12 //latch pin

RTC_DS3231 rtc;

unsigned int crtime = 0; //the current time
unsigned int lstime = 0; //last time

void setup () {
  pinMode(DS, OUTPUT);
  pinMode(STCP, OUTPUT);
  pinMode(SHCP, OUTPUT);
  pinMode(3, INPUT_PULLUP); //time increase button
  pinMode(2, INPUT_PULLUP); //time decrease button
  Serial.begin(9600);
  if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
    while (1);
  }

rtc.writeSqwPinMode(0x00); //set ds3231 to output 1hz square wave
//rtc.adjust(DateTime(F(__DATE__), F(__TIME__))+TimeSpan(0,0,0,8)); //set time

  DateTime now = rtc.now();
  crtime = now.hour()*100 + now.minute();
  nixie(crtime);

}

void loop () {
  DateTime now = rtc.now();
  crtime = now.hour()*100 + now.minute();
  if(crtime != lstime){
    lstime = crtime;
    nixie(crtime);
    //Serial.print(crtime, DEC);
    //Serial.println();
  }
  if(digitalRead(3)==0){
    boolean first = 1;
    while(digitalRead(3)==0){
      now = rtc.now();
      rtc.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), now.minute(), 0)+TimeSpan(0,0,1,0));
      now = rtc.now();
      crtime = now.hour()*100 + now.minute();
      nixie(crtime);
      Serial.print(now.hour(), DEC);
      Serial.print(':');
      Serial.print(now.minute(), DEC);
      Serial.print(':');
      Serial.print(now.second(), DEC);
      Serial.println();
      if(first){ delay(100); first = 0;}
      delay(100);
    }
    delay(100);
  }
  if(digitalRead(2)==0){
    boolean first = 1;
    while(digitalRead(2)==0){
      now = rtc.now();
      rtc.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), now.minute(), 0)-TimeSpan(0,0,1,0));
      now = rtc.now();
      crtime = now.hour()*100 + now.minute();
      nixie(crtime);
      Serial.print(now.hour(), DEC);
      Serial.print(':');
      Serial.print(now.minute(), DEC);
      Serial.print(':');
      Serial.print(now.second(), DEC);
      Serial.println();
      if(first){ delay(100); first = 0;}
      delay(100);
    }
    delay(100);
  }

  Serial.print(now.hour(), DEC);
  Serial.print(':');
  Serial.print(now.minute(), DEC);
  Serial.print(':');
  Serial.print(now.second(), DEC);
  Serial.println();
    
  delay(100);
}


void nixie(unsigned int number){
    byte thou = number / 1000;
    number = number-thou*1000;
    byte hund = number / 100;
    number = number-hund*100;
    byte tens = number / 10;
    number = number-tens*10;
    byte ones = number;

    ones = ones + 16*tens;  //combined ones and tens
    hund = hund + 16*thou;  //combined hundreds and thousands

    digitalWrite(STCP, LOW); //latch low
    shiftOut(DS, SHCP, MSBFIRST, hund);
    shiftOut(DS, SHCP, MSBFIRST, ones);
    digitalWrite(STCP, HIGH); //latch high
}
