#define DS    10  //data pin
#define STCP  11 //latch pin
#define SHCP  12 //clock pin

void setup() {
  //set pins to output so you can control the shift register
  pinMode(DS, OUTPUT);
  pinMode(STCP, OUTPUT);
  pinMode(SHCP, OUTPUT);
  Serial.begin(9600);
}

void loop() {
    for(unsigned long i = 0; i <= 999999; i++){
      nixie(i);
      delay(1);
    }
}

void nixie(long number){
    number = abs(number);
    byte hthou = number / 100000L;
    number = number-hthou*100000L;
    byte tthou = number / 10000L;
    number = number-tthou*10000L;
    byte thou = number / 1000L;
    number = number-thou*1000L;
    byte hund = number / 100L;
    number = number-hund*100L;
    byte tens = number / 10L;
    number = number-tens*10L;
    byte ones = number;

    /*
    Serial.print(hthou);
    Serial.print(tthou);
    Serial.print(thou);
    Serial.print(hund);
    Serial.print(tens);
    Serial.print(ones);
    Serial.println();
    */

    ones = ones + 16*tens;  //combined ones and tens
    hund = hund + 16*thou;  //combined hundreds and thousands
    tthou = tthou + 16*hthou;

    digitalWrite(STCP, LOW); //latch low
    shiftOut(DS, SHCP, MSBFIRST, tthou);
    shiftOut(DS, SHCP, MSBFIRST, hund);
    shiftOut(DS, SHCP, MSBFIRST, ones);
    digitalWrite(STCP, HIGH); //latch high
}

